Unit Disk;

Interface

Uses List;

Const
  plink_mask : String = '*.92?'; {as a default, see INI}
Var
  plink_path : String; {as a default, see INI}

Procedure TIload (Var action : Byte; Var id : String);
Function Get_current_path : String;
Procedure DOS_change_dir (d : String);
Procedure DOS_new_dir (d : String);
Procedure DOS_ren_file (old,new : String);
Function DOS_disk_free : LongInt;
Procedure DOS_change_drive (letter : Char);

Implementation

Uses Buttons,Debug,Dos,Keyb,Mouse,TI92,TIdef,Timer,Txt;

Const
  diskstatus = '      '#0#116'Left clic'#0#112' Select/Deselect            '#0#116'Right clic'#0#112' Display file info';
  maxfitem = 255;
  limit : Boolean = True;
  last_pos : Word = 1;
  load1 : button = (x:49; y:3;  l:10; txt:'   '#0#116'L'#0#112'oad   '; k:'L');
  load7 : button = (x:49; y:5;  l:10; txt:'   '#0#116'M'#0#112'erge  '; k:'M');
  load8 : button = (x:49; y:7;  l:10; txt:' Load '#0#116'T'#0#112'xt '; k:'T');
  save1 : button = (x:49; y:5;  l:10; txt:'  '#0#116'G'#0#112'roup   '; k:'G');
  save7 : button = (x:49; y:7;  l:10; txt:' '#0#116'S'#0#112'eparate '; k:'S');
  bmp1  : button = (x:49; y:5;  l:10; txt:'   '#0#116'S'#0#112'ave   '; k:'S');
  load2 : button = (x:49; y:9;  l:10; txt:'   Mas'#0#116'k'#0#112'   '; k:'K');
  load3 : button = (x:49; y:11; l:10; txt:' '#0#116'N'#0#112'ew  dir '; k:'N');
  load4 : button = (x:49; y:13; l:10; txt:'  '#0#116'R'#0#112'ename  '; k:'R');
  load5 : button = (x:49; y:15; l:10; txt:'  '#0#116'D'#0#112'elete  '; k:'D');
  load6 : button = (x:49; y:17; l:10; txt:'   E'#0#116'x'#0#112'it   '; k:'X');
  save8 : button = (x:49; y:3;  l:10; txt:'  '#0#116'B'#0#112'ackup  '; k:'B');
  loadset : bset = (@load1,@load2,@load3,@load4,@load5,@load6,@load7,nil,
                  nil,nil,nil,nil,nil,nil,nil,nil);
  delyes : button = (x:30; y:13; l:7; txt:'  '#0#116'Y'#0#112'es  '; k:'Y');
  delno  : button = (x:43; y:13; l:6; txt:'  '#0#116'N'#0#112'o  '; k:'N');
  delset : bset = (@delyes,@delno,nil,nil,nil,nil,nil,nil,
                  nil,nil,nil,nil,nil,nil,nil,nil);
Type
  fitem = Record
            name : String[12];
            size : LongInt;
          End;
  flist = Record
            sign : Boolean;
            x,xs,y1,y2,len : Byte;
            nb,ofs,sel : Word;
            item : Array [1..maxfitem] Of fitem;
          End;
Var
  release : Boolean;
  dir : ^flist;

Procedure Disp_fitem (Var l : flist; n : Word);
Const
  void = '                     ';
Var
  y : Byte;
  color : Array [1..2] Of Char;
Begin
  With l Do
  Begin
    y :=y1+n-ofs;
    If (y>=y1) And (y<=y2) Then
    Begin
      If (l.sel>0) And (l.sel=n) Then
        Text (x,y,#0#64+void)
      Else
        Text (x,y,#0#16+void);
      If (n<=nb) Then
        With item[n] Do
          Case size Of
            -1: Begin
                  If l.sel=n Then
                    color :=#0#78
                  Else
                    color :=#0#30;
                  Text (x,y,color+name);
                  Text (x+13,y,color+'   (DIR)');
                End;
            -2: Begin
                  If l.sel=n Then
                    color :=#0#75
                  Else
                    color :=#0#27;
                  Text (x,y,color+name);
                  Text (x+13,y,color+'   (VOL)');
                End;
              Else
                Begin
                  If l.sel=n Then
                    color :=#0#79
                  Else
                    color :=#0#31;
                  Text (x,y,color+name);
                  Text (x+13,y,color+Number (8,size));
                End;
          End;
    End;
  End;
End;

Procedure Disp_flist (Var l : flist);
Var
  i,j : Byte;
  a,b,c : Word;
  s : String;
Begin
  With l Do
  Begin
    Hide_mouse;
    For i :=ofs To ofs+y2-y1+1 Do
      Disp_fitem (l,i);
    Text (xs,y1,#0#23'');
    For i :=y1+1 To y2-1 Do
      Text (xs,i,#0#23'');
    Text (xs,y2,#0#23'');
    If nb>0 Then
    Begin
      c :=Word (((y2-y1+1)*(y2-y1-1)) Div nb);
      If c>(y2-y1-1) Then c :=y2-y1-1;
      If ofs=1 Then b :=y1+1 Else
        b :=y1+2+Word (((y2-y1-2-c)*(ofs-1)) Div (nb-(y2-y1+1)));
      For a :=b To b+c-1 Do Text (xs,a,'');
    End;
    Text (20,3,'                       ');
    s :=plink_path+'\'+plink_mask;
    b :=Length (s);
    If b>23 Then
    Begin
      For a :=2 To 23 Do
        s[a] :=s[b-23+a];
      s :=#27;
      s[0] :=#23;
    End;
    Text (20,3,#0#30+s);
    Text (20,18,#0#27+'                        ');
    Text (20,18,#0#27+NumberHi (10,DOS_disk_free)+' Bytes free');
    Show_mouse;
  End;
End;

Function Flist_up (Var l : flist) : Boolean;
Begin
  If (l.ofs>1) Then
    Begin
      Dec (l.ofs);
      If (l.sel>l.ofs+l.y2-l.y1) Then
        Dec (l.sel);
      Disp_flist (l);
      Flist_up :=True;
      If release Then
        Begin
          Delay (list_delay);
          release :=False;
        End
      Else
        Delay (list_speed);
    End
  Else
    Flist_up :=False;
End;

Function Flist_dn (Var l : flist) : Boolean;
Begin
  If (l.ofs+l.y2-l.y1<l.nb) Then
    Begin
      Inc (l.ofs);
      If (l.sel>0) And (l.sel<l.ofs) Then
        Inc (l.sel);
      Disp_flist (l);
      Flist_dn :=True;
      If release Then
        Begin
          Delay (list_delay);
          release :=False;
        End
      Else
        Delay (list_speed);
    End
  Else
    Flist_dn :=False;
End;

Procedure Get_dir (Var l : flist);
Var
  changed : Boolean;
  i,j,max : Byte;
  z : fitem;
  search : SearchRec;
Begin
  With l Do
  Begin
    nb :=0;
    {folders:}
    FindFirst (plink_path+'\*.*',AnyFile,search);
    While DosError=0 Do
    Begin
      If (search.attr=16) And (search.name<>'.') Then
      Begin
        Inc (nb);
        With item[nb] Do
        Begin
          name :=search.name;
          size :=-1;
        End;
      End;
      Findnext (search);
    End;
    Repeat
      changed :=False;
      For i :=2 To nb Do
        If item[i-1].name>item[i].name Then
        Begin
          z :=item[i-1];
          item[i-1] :=item[i];
          item[i] :=z;
          changed :=True;
        End;
    Until Not changed;
    {files:}
    j :=nb+2;
    FindFirst (plink_path+'\'+plink_mask,AnyFile,search);
    While (DosError=0) And (nb<maxfitem) Do
    Begin
      If search.attr<>16 Then
      Begin
        Inc (nb);
        With item[nb] Do
        Begin
          name :=search.name;
          size :=search.size;
        End;
      End;
      Findnext (search);
    End;
    Repeat
      changed :=False;
      For i :=j To nb Do
        If item[i-1].name>item[i].name Then
        Begin
          z :=item[i-1];
          item[i-1] :=item[i];
          item[i] :=z;
          changed :=True;
        End;
    Until Not changed;
    sel :=0;
    {drives:}
    If (nb<=maxfitem) Then
    Begin
      Asm
        mov  ah,19h
        int  21h

        mov  ah,0Eh
        mov  dl,al
        int  21h
        mov  max,al
      End;
      For i :=1 To max Do
      Begin
        Inc (nb);
        With item[nb] Do
        Begin
          name :=Chr (64+i)+':';
          size :=-2;
        End;
      End;
    End;
    If nb>=(last_pos+y2-y1) Then
      ofs :=last_pos
    Else
      ofs :=1;
  End;
End;

Procedure Preview (fname : String);
Var
  w : Word;
  sign : TIstr;
  comment : Array [1..40] Of Char;
  f : File;
Begin
  Assign (f,fname);
  Reset (f,1);
  BlockRead (f,sign,8);
  Text (20,20,'                                        ');
  Text (20,21,'                                        ');
  If sign='**TI92**' Then
    Begin
      dir^.sign :=True;
      BlockRead (f,w,2);
      Text (20,20,fname+' : TI92 file v'+Number (1,w And $FF)+'.'+Number (1,w Shr 8));
      BlockRead (f,sign,8);
      BlockRead (f,comment,40);
      Text (20,21,#0#23+PascalStr (comment,40));
    End
  Else
    Begin
      dir^.sign :=False;
      Text (20,20,fname+' : Unknown format');
    End;
  Close (f);
End;

Procedure Check_flist (Var l : flist; mx,my : Byte);
Var
  c,my0,mc,mx2,my2 : Byte;
  i,j : Word;
Begin
  With l Do
  Begin
    If (Abs (mx-xs)<=1) Then
    Begin
      If (my>=y1) And (my<=y1+2) Then
        Flist_up (l);
      If (my>=y2-2) And (my<=y2) Then
        Flist_dn (l);
    End;
    If (mx>=x) And (mx<x+len) Then
    Begin
      If (my>=y1) And (my<=y2) Then
      Begin
        limit :=True;
        i :=my+ofs-y1;
        If (i<=nb) Then
        Begin
          If (limit) And (item[i].name<>'..') Then
          Begin
            Hide_mouse;
            j :=sel;
            sel :=i;
            Disp_fitem (l,j);
            Disp_fitem (l,sel);
            Show_mouse;
            If dir^.item[sel].size>=0 Then
              Preview (dir^.item[sel].name);
       {     Repeat
              mx2 :=mx;
              my2 :=my;
              Get_mouse_XY (mx,my);
              mc :=Get_mouse_clic;
            Until (mx<>mx2) Or (my<>my2) Or (mc=0);}
          End;
          If (my>=y1) And (my<=y2) Then
          Begin
            my0 :=my;
            Repeat
              Get_mouse_XY (mx,my);
              c :=Get_mouse_clic;
            Until (c=0) Or (my<>my0) Or (mx<x) Or (mx>=x+len);
            If c=0 Then release :=True;
          End;
        End;
      End;
    End;
  End;
End;

Procedure Delete (Var l : flist);
Var
  d : String;
Begin
  With l Do
    If sel>0 Then
    Begin
      d :=item[sel].name+#0;
      If item[sel].size=-1 Then
        Asm
          push ds
          mov  ah,3Ah
          mov  bx,ss
          mov  ds,bx
          mov  dx,bp
          sub  dx,255
          int  21h
          pop  ds
        End
      Else
        Asm
          push ds
          mov  ah,41h
          mov  bx,ss
          mov  ds,bx
          mov  dx,bp
          sub  dx,255
          int  21h
          pop  ds
        End;
    End;
  Get_dir (dir^);
  Disp_flist (dir^);
End;

Procedure Rename (Var l : flist);
Begin
  With l Do
    If sel>0 Then
    Begin
    End;
End;

Procedure TIload (Var action : Byte; Var id : String);
Var
  mc,mx,my,_mode : Byte;
  ch : Char;
  but,w : Word;
  s : String;
Begin
  _mode :=action; {1->load 2->save}
  action :=0;
  id :='';
  New (dir); Inc (_malloc,SizeOf (flist));
  With dir^ Do
  Begin
    sign :=False;
    xs :=20;
    x :=22;
    y1 :=5;
    y2 :=16;
    len :=21;
  End;
  Get_dir (dir^);
  Hide_mouse;
  Case _mode Of
    1: Begin
         loadset[1] :=@load1;
         loadset[7] :=@load7;
         loadset[8] :=@load8;
         Dialog (19,2,60,21,' Load a TI92 archive ');
       End;
    2: Begin
         loadset[1] :=@save1;
         loadset[7] :=@save7;
         loadset[8] :=@save8;
         Dialog (19,2,60,21,' Save a TI92 archive ');
       End;
    3: Begin
         loadset[1] :=@bmp1;
         loadset[7] :=nil;
         loadset[8] :=nil;
         Dialog (19,2,60,21,' Save screen bitmap as BMP ');
       End;
  End;
  Draw_set (loadset);
  Text (18,19,'Ĵ');
{  Status (24,diskstatus);}
  Show_mouse;
  Disp_flist (dir^);

  Repeat
    but :=0;
    Get_mouse_XY (mx,my);
    mc :=Get_mouse_clic;
    If (mc=0) Then release :=True;
    If (mc=1) Or Key (ch) Then
      but :=Check_set (loadset,mx,my,ch);
    If mc=1 Then
      check_flist (dir^,mx,my);
    If mc=$81 Then
      If (my>=dir^.y1) And (my<=dir^.y2) And (mx>=dir^.x) And (mx<dir^.x+dir^.len) Then
      Begin
        w :=dir^.ofs+my-dir^.y1;
        If (w<=dir^.nb) And (dir^.item[w].size=-1) Then
          Begin
            DOS_change_dir (dir^.item[w].name);
            plink_path :=Get_current_path;
            Get_dir (dir^);
            Disp_flist (dir^);
          End
        Else
          If (w<=dir^.nb) And (dir^.item[w].size=-2) Then
          Begin
            DOS_change_drive (dir^.item[w].name[1]);
            plink_path :=Get_current_path;
            Get_dir (dir^);
            Disp_flist (dir^);
          End;
      End;

    If (_mode>1) Or ((dir^.sel>0) And (dir^.item[dir^.sel].size>=0) And dir^.sign) Then
    Begin
      If (but=1) Then
      Begin
        action :=1;
        If dir^.sel>0 Then
          id :=dir^.item[dir^.sel].name;
        but :=6;
      End;
      If (but=7) Then
      Begin
        action :=2;
        If dir^.sel>0 Then
          id :=dir^.item[dir^.sel].name;
        but :=6;
      End;
    End;
    If (but=8) Then
    Begin
      If (_mode=1) And (dir^.sel>0) And (dir^.item[dir^.sel].size>=0) Then
      Begin
        action :=8;
        If dir^.sel>0 Then
          id :=dir^.item[dir^.sel].name;
        but :=6;
      End;
      If (_mode=2) Then
      Begin
        action :=3;   {Save backup}
        If (dir^.sel>0) And (dir^.item[dir^.sel].size>=0) Then
          id :=dir^.item[dir^.sel].name;
        but :=6;
      End;
    End;
    If (but=2) Then
    Begin
      s :=UpCase (Enter (' Change file mask ','Enter new mask : ',12));
      If s<>'' Then
      Begin
        plink_mask :=s;
        Get_dir (dir^);
        Disp_flist (dir^);
      End;
    End;
    If (but=3) Then
    Begin
      s :=Enter (' Create a new folder ',' Enter folder name : ',12);
      If s<>'' Then
      Begin
        DOS_new_dir (s);
        Get_dir (dir^);
        Disp_flist (dir^);
      End;
    End;
    If (but=4) And (dir^.sel>0) And (dir^.item[dir^.sel].size<>-2) Then
    Begin
      s :=Enter (' Rename file or folder ',' Enter new name for "'+dir^.item[dir^.sel].name+'" : ',12);
      If s<>'' Then
      Begin
        DOS_ren_file (dir^.item[dir^.sel].name,s);
        Get_dir (dir^);
        Disp_flist (dir^);
      End;
    End;
    If (but=5) And (dir^.sel>0) And (dir^.item[dir^.sel].size<>-2) And
       (Choice (' Warning ',' Delete selected item ? ',delset)=1) Then
      Delete (dir^);
  Until but=6;

  End_dialog;
{  Status (24,'');}
  last_pos :=dir^.ofs;
  Dispose (dir); Inc (_mfree,SizeOf (flist));
End;

Function Get_current_path : String;
Type
  pChar = Array [1..64] Of Char;
Var
  s : ^pChar;
  u,v : String[64];
  a : Byte;
Begin
  New (s); Inc (_malloc,SizeOf (pChar));
  Asm
    push ds
    mov  ah,19h
    int  21h
    mov  a,al

    mov  ax,[bp-2]
    mov  ds,ax
    mov  si,[bp-4]
    mov  ah,47h
    mov  dl,0
    int  21h
    pop  ds
  End;
  u :=Chr (a+65)+':';
  v :=PascalStr (s^,64);
  If Length (v)>0 Then
    u :=u+'\'+v;
  Get_current_path :=u;
  Dispose (s); Inc (_mfree,SizeOf (pChar));
End;

Procedure DOS_change_dir (d : String);
Begin
  d :=d+#0;
  Asm
    push ds
    mov  ah,3Bh
    mov  bx,ss
    mov  ds,bx
    mov  dx,bp
    sub  dx,255
    int  21h
    pop  ds
  End;
End;

Procedure DOS_new_dir (d : String);
Begin
  d :=d+#0;
  Asm
    push ds
    mov  ah,39h
    mov  bx,ss
    mov  ds,bx
    mov  dx,bp
    sub  dx,255
    int  21h
    pop  ds
  End;
End;

Procedure DOS_ren_file (old,new : String);
Begin
  old :=old+#0;
  new :=new+#0;
  Asm
    push ds
    mov  bx,ss
    mov  ds,bx
    mov  dx,bp
    sub  dx,255
    mov  es,bx
    mov  di,bp
    sub  di,255+256

    mov  ah,56h
    int  21h
    pop  ds
  End;
End;

Function DOS_disk_free : LongInt;
Var
  a,b,c : Word;
Begin
  Asm
    mov  ah,36h
    mov  dl,0
    int  21h
    mov  a,ax
    mov  b,bx
    mov  c,cx
  End;
  Dos_disk_free :=LongInt (a)*LongInt (b)*LongInt (c);
End;

Procedure DOS_change_drive (letter : Char); Assembler;
Asm
  mov  ah,0Eh
  mov  dl,letter
  cmp  dl,97
  jb   @ok
       sub  dl,32
  @ok:
  sub  dl,65
  int  21h
End;

End.
