Unit TIdef;

Interface

Type
  _array = Array [0..255] Of Byte;
  p_array = ^_array;
  TIstr = Array [1..8] Of Char;
  packet = Record
             typ : Byte;
             size : Word;
             data : p_array;
           End;
  ppacket = ^packet;
  TIvar = Record
            size  : LongInt;
            typ   : Byte;
            sel   : Boolean;
            dir   : TIstr;
            name  : TIstr;
            dsize : LongInt;
            data  : p_array;
          End;
  pTIvar = ^TIvar;
  h92g = Record
           sign    : TIstr;
           version : Word;
           dummy   : TIstr;
           comment : Array [1..40] Of Char;
           nb      : Word;
         End;
  p92g = Record
           ptr   : LongInt;
           name  : TIstr;
           typ   : Byte;
           a,b,c : Byte;
         End;
  h92b = Record
           sign    : TIstr;
           version : Word;
           dummy   : TIstr;
           comment : Array [1..40] Of Char;
           nb      : Word;
           ptr     : LongInt;
           ROM     : TIstr;
           typ     : Byte;
           a,b,c   : Byte;
           fsize   : LongInt;
           hend    : Word;
         End;
  mpack = Array [1..255] Of packet;
Const
  TIinter_get : Word = 10;
  TIinter_send : Word = 0;
  TItime_out = 20; {20/18.2 sec > wake up delay if TI is off = 820 ms}
  TIsearch_max : Word = 2;
  Skip_TI_reset : Boolean = False;
  TIblank : TIstr = '        ';
  TI_type : Array [0..31,1..4] Of Char =
  ('EXPR','????','????','????','LIST','????','MAT ','????',
   '????','????','DATA','TEXT','STR ','GDB ','FIG ','????',
   'PIC ','????','PGRM','FUNC','MAC ','????','????','????',
   '????','????','????','????','????','????','ROOT','DIR ');
  TIext : Array [0..31] Of Char =
  ('e','?','?','?','l','?','m','?',
   '?','?','c','t','s','d','a','?',
   'i','?','p','f','x','?','?','?',
   '?','?','?','?','?','?','?','?');
  TIerror_str : Array [1..5] Of String[16] =
  ('ESC pressed',
   'time out',
   'TI92 not ready',
   'bad checksum',
   'unexpected data');
  ports_add : Array [1..8] Of Word = (0,0,0,0,0,0,0,0);
  ports_str : Array [1..8,1..4] Of Char =
  ('COM1','COM2','COM3','COM4','LPT1','LPT2','LPT3','LPT4');
  port_id : Byte = 5;
  P_iteration : Word = 8;
Var
  P_out,P_in,S_base,TIerror : Word;

Implementation

End.

