Unit TIedit;

{****************************************************************************}
Interface
{****************************************************************************}

Uses TIdef;

Function Edit_txt (v : pTIvar) : Boolean;
Function TXT_to_TI (fname : String; dest : TIstr) : pTIvar;

{****************************************************************************}
Implementation
{****************************************************************************}

Uses Buttons,Debug,Keyb,Txt;

Const
  max_x = 38;
  max_y = 1600;
  max_disp = 12;
  origin_x = 21;
  origin_y = 6;
  end_x = origin_x+max_x-1;
  end_y = origin_y+max_disp-1;
  void = #0#31'                                      ';
  _return   = #20;
  _terminal = #4;
  visible : Boolean = True;
  overwrite : Boolean = False;
  getover : button = (x:23; y:13; l:11; txt:' '#0#116'O'#0#112'verwrite '; k:'O');
  getren  : button = (x:37; y:13; l:8;  txt:' '#0#116'R'#0#112'ename '; k:'R');
  getskip : button = (x:49; y:13; l:6;  txt:' '#0#116'S'#0#112'kip '; k:'S');
  getset : bset = (@getover,@getren,@getskip,nil,nil,nil,nil,nil,
                   nil,nil,nil,nil,nil,nil,nil,nil);
Type
  txt_buff = Array [1..max_y,1..max_x] Of Char;
Var
  _key : Char;
  disp,len,x,y : Word;
  buffer : ^txt_buff;
{ disp = 1..max(1,len) }

Procedure _Text (visible : Boolean; x,y : Byte; s : String);
Var
  a : Byte;
  ofs,w : Word;
Begin
  ofs :=y*160+x Shl 1;
  w :=31 Shl 8;
  a :=1;
  Repeat
    If (s[a]=_terminal) Or (s[a]=_return) Then
      If visible Then
        w :=27 Shl 8
      Else
        s[a] :=#32;
    MemW[$B800:ofs] :=Ord (s[a])+w;
    Inc (ofs,2);
    Inc (a);
  Until a>Length (s);
End;

Procedure TI_to_PC (v : pTIvar);
Var
  b,c : Byte;
  a,l : LongInt;
  pos,_x,_y,w : Word;
Begin
  With v^ Do
  Begin
    l :=data^[2] Shl 24;
    Inc (l,data^[3] Shl 16);
    Inc (l,data^[4] Shl 8);
    Inc (l,data^[5]);
    pos :=8+data^[6] Shl 8;
    Inc (pos,data^[7]);
    _x :=1;
    _y :=1;
    w :=9;
    If data^[w]<>0 Then
      Repeat
        b :=data^[w];
        If (w=pos) Then
        Begin
          x :=_x;
          y :=_y-1;
        End;
        Inc (w);
        If b=13 Then
          Begin
            buffer^[_y,_x] :=_return;
            For c :=_x+1 To max_x Do
              buffer^[_y,c] :=' ';
            _x :=1;
            Inc (_y);
            Inc (w); {saute le #32 de debut de ligne}
          End
        Else
          Begin
            buffer^[_y,_x] :=Chr (b);
            Inc (_x);
            If _x>max_x Then
            Begin
              _x :=1;
              Inc (_y);
            End;
          End;
      Until (data^[w]=0) Or (_y>max_y);
  End;
  buffer^[_y,_x] :=_terminal;
  If (w=pos) Then
  Begin
    x :=_x;
    y :=_y-1;
  End;

  For c :=_x+1 To max_x Do
    buffer^[_y,c] :=' ';
  len :=_y;
  disp :=1;
  If y>=max_disp Then
  Begin
    disp :=2+y-max_disp;
    y :=max_disp-1;
  End;
End;

Procedure PC_to_TI (p : pTIvar);
Var
  ch : Char;
  i,j,count,pos : Word;
Begin
  count :=10;
  For j :=1 To len Do
  Begin
    i :=0;
    Repeat
      Inc (i);
      If (disp+y=j) And (x=i) Then
        pos :=count-9;
      ch :=buffer^[j,i];
      Inc (count);
    Until (i=max_x) Or (ch=_terminal) Or (ch=_return);
    If ch=_return Then
      Inc (count);
  End;
  With p^ Do
  Begin
    FreeMem (data,dsize); Inc (_mfree,dsize);
    dsize :=count;
    GetMem (data,dsize); Inc (_malloc,dsize);
    Dec (count,4);
    size :=count;
    Dec (count,2);
    data^[0] :=0;
    data^[1] :=0;
    data^[2] :=count Shr 24; { :=Byte (...) }
    data^[3] :=count Shr 16;
    data^[4] :=count Shr 8;
    data^[5] :=count;
    data^[6] :=pos Shr 8;
    data^[7] :=pos;
    data^[8] :=32;
    count :=9;
    For j :=1 To len Do
    Begin
      i :=0;
      Repeat
        Inc (i);
        ch :=buffer^[j,i];
        Case ch Of
          _terminal: data^[count] :=0;
          _return  : data^[count] :=13;
          Else
            data^[count] :=Ord (ch);
        End;
        Inc (count);
      Until (i=max_x) Or (ch=_terminal) Or (ch=_return);
      If ch=_return Then
      Begin
        data^[count] :=32;
        Inc (count);
      End;
    End;
    data^[count] :=$E0;
  End;
End;

Procedure Move_cursor;
Begin
  Set_cursor (origin_x-1+x,origin_y+y);
  Text (origin_x+1,end_y+1,Number (2,x)+':'+Number (3,disp+y));
End;

Procedure Disp_line (num : Word);
Begin
  If (num>=disp) And (num<disp+max_disp) Then
    If num<=len Then
      _Text (visible,origin_x,origin_y+num-disp,buffer^[num])
    Else
      Text (origin_x,origin_y+num-disp,void);
End;

Procedure End_of_line;
Var
  i : Word;
Begin
  i :=max_x;
  While (i>0) And (buffer^[disp+y,i]<>_return) Do
    Dec (i);
  If i=0 Then
    i :=max_x;
  x :=i;
End;

Procedure Check_end_of_line;
Var
  i : Word;
Begin
  i :=1;
  While (i<=max_x) And (buffer^[disp+y,i]<>_return) And (buffer^[disp+y,i]<>_terminal) Do
    Inc (i);
  If (i<x) Then x :=i;
End;

Procedure Go_up;
Var
  i : Word;
Begin
  If (disp+y>1) Then
    If (y=0) Then
      Begin
        Dec (disp);
        For i :=disp To disp+max_disp-1 Do
          Disp_line (i);
        Check_end_of_line;
      End
    Else
      Begin
        Dec (y);
        Check_end_of_line;
      End;
  Move_cursor;
End;

Procedure Go_dn;
Var
  i : Word;
Begin
  If (disp+y<len) Then
    If (y+1=max_disp) Then
      Begin
        Inc (disp);
        For i :=disp To disp+max_disp-1 Do
          Disp_line (i);
        Check_end_of_line;
      End
    Else
      Begin
        Inc (y);
        Check_end_of_line;
      End;
  Move_cursor;
End;

Procedure Go_left;
Var
  i : Word;
Begin
  If (x>1) Then
    Dec (x)
  Else
    If (y>0) Then
      Begin
        Dec (y);
        End_of_line;
      End
    Else
      If (disp>1) Then
      Begin
        Dec (disp);
        For i :=disp To disp+max_disp-1 Do
          Disp_line (i);
        End_of_line;
      End;
  Move_cursor;
End;

Procedure Go_right;
Var
  i : Word;
Begin
  If (buffer^[disp+y,x]<>_terminal) Then
  Begin
    If (x<max_x) And (buffer^[disp+y,x]<>_return) Then
      Inc (x)
    Else
      If (y<max_disp-1) Then
        Begin
          Inc (y);
          x :=1;
        End
      Else
        If (disp+max_disp-1<len) Then
        Begin
          Inc (disp);
          For i :=disp To disp+max_disp-1 Do
            Disp_line (i);
          x :=1;
        End;
    Move_cursor;
  End;
End;

Procedure Del_char (u,v : Word);
Var
  a,i,j : Word;
Begin
  If buffer^[v,u]=_return Then
    Begin
      buffer^[v,u] :=' ';
      For i :=u To max_x Do
        Del_char (u,v);
    End
  Else
    If buffer^[v,u]<>_terminal Then
    Begin
      Repeat
        i :=u;
        j :=v;
        If u<max_x Then
          Begin
            Inc (u);
            buffer^[j,i] :=buffer^[v,u];
          End
        Else
          If (v<len) Then
          Begin
            u :=1;
            Inc (v);
            buffer^[j,i] :=buffer^[v,u];
            Disp_line (v-1);
          End;
      Until (buffer^[v,u]=_return) Or (buffer^[v,u]=_terminal);
      If (i=max_x) And ((buffer^[j,i]=_return) Or (buffer^[v,u]=_terminal)) Then
        Begin
          For a :=v To len-1 Do
            buffer^[a] :=buffer^[a+1];
          Dec (len);
{          If (disp+max_disp>=len) And (disp>1) Then
            Dec (disp);}
          For a :=disp To disp+max_disp-1 Do
            Disp_line (a);
        End
      Else
        buffer^[v,u] :=' ';
      Disp_line (v);
    End;
End;

Procedure Insert_char (ch : Char);
Var
  next,_next : Char;
  a,i,j,_i,_j : Word;
Begin
  If overwrite And (buffer^[disp+y,x]<>_return) And (buffer^[disp+y,x]<>_terminal) And (ch<>#13) Then
    Begin
      Buffer^[disp+y,x] :=ch;
      Disp_line (disp+y);
    End
  Else
    Begin
      i :=x;
      j :=disp+y;
      If ch=#13 Then
        Begin
          Inc (len);
          For a :=len DownTo j+1 Do
            buffer^[a] :=buffer^[a-1];
          buffer^[j,i] :=_return;
          For a :=i+1 To max_x Do
            buffer^[j,a] :=' ';
          Inc (j);
          _j :=j;
          _i :=1;
          next :=buffer^[j,i];
          While (next<>_return) And (next<>_terminal) Do
          Begin
            buffer^[_j,_i] :=next;
            Inc (i);
            If i>max_x Then
            Begin
              i :=1;
              Inc (j);
            End;
            Inc (_i);
            If _i>max_x Then
            Begin
              _i :=1;
              Inc (_j);
            End;
            next :=buffer^[j,i];
          End;
          buffer^[_j,_i] :=next;
          For a :=_i+1 To max_x Do
            buffer^[_j,a] :=' ';
          If (_j<>j) Then  {actually _j<j}
          Begin
            Dec (len);
            For a :=j To len Do
              buffer^[a] :=buffer^[a+1];
          End;
          For a :=disp+y To disp+max_disp-1 Do
            Disp_line (a);
        End
      Else
        Begin
          next :=buffer^[j,i];
          buffer^[j,i] :=ch;
          While (next<>_return) And (next<>_terminal) Do
          Begin
            Inc (i);
            If i>max_x Then
            Begin
              i :=1;
              Disp_line (j);
              Inc (j);
            End;
            _next :=next;
            next :=buffer^[j,i];
            buffer^[j,i] :=_next;
          End;
          Inc (i);
          If i>max_x Then
          Begin
            i :=1;
            Disp_line (j);
            Inc (j);
            Inc (len);
            For a :=len DownTo j+1 Do
            Begin
              buffer^[a] :=buffer^[a-1];
              Disp_line (a);
            End;
            buffer^[j] :='                                      ';
            i :=1;
          End;
          buffer^[j,i] :=next;
          Disp_line (j);
        End;
    End;
  Go_right;
  Move_cursor;
End;

Procedure TI_to_TXT;
Const
  rc : Array [1..2] Of Char = #13#10;
Var
  ch : Char;
  event,i,j,w : Word;
  s : String;
  f : File;
Label
  nop;
Begin
  Repeat
    s :=Short (Enter (' Save TEXT var as TXT file ','(.TXT added if no extension specified) :',12));
    If s='' Then
      Goto nop;
    w :=Length (s);
    If w>9 Then
      w :=9;
    i :=2;
    While (i<=w) And (s[i]<>'.') Do
      Inc (i);
    If i>w Then
      s :=Copy (s,1,8)+'.TXT';
    Assign (f,s);
    w :=IOresult;
    Reset (f,1);
    event :=1;
    If IOresult=0 Then
    Begin
      Close (f);
      event :=Choice (' Save TEXT var as TXT file ','   File "'+s+'" already exists.   ',getset)
    End;
    If event=3 Then
      Goto nop;
  Until event=1;
  {s=file_name}
  Rewrite (f,1);
  For j :=1 To len Do
  Begin
    i :=0;
    Repeat
      Inc (i);
      ch :=buffer^[j,i];
      If ch<>_terminal Then
        If ch=_return Then
          BlockWrite (f,rc,2)
        Else
          BlockWrite (f,ch,1);
    Until (i=max_x) Or (ch=_return) Or (ch=_terminal);
  End;
  Close (f);
  nop:
  Show_cursor;
End;

Function Edit_txt (v : pTIvar) : Boolean;
Var
  i : Word;
Begin
  Edit_txt :=False;
  New (buffer); Inc (_malloc,SizeOf (txt_buff));
  Dialog (origin_x,origin_y,end_x,end_y,' '+Short (v^.name)+' ');
  Status (24,#0#116'ESC'#0#112'-Forget edit   '#0#116'F2'#0#112'-save as TXT   '+
             #0#116'F9'#0#112'-Update variable   '#0#116'F10'#0#112'-Symbols');
  If overwrite Then
    Text (70,24,#0#126'Overwrite')
  Else
    Text (70,24,#0#126'   Insert');
  TI_to_PC (v);
{  disp :=1;
  x :=1;
  y :=0;}
  For i :=disp To disp+max_disp-1 Do
    Disp_line (i);
  Move_cursor;
  Show_cursor;

  Repeat
    Repeat
    Until KeyPressed;
    _key :=ReadKey;

    Case _key Of
{Ins} #210: Begin
              overwrite :=Not overwrite;
              If overwrite Then
                Text (70,24,#0#126'Overwrite')
              Else
                Text (70,24,#0#126'   Insert');
            End;
{F10} #196: Begin
              visible := Not visible;
              For i :=disp To disp+max_disp-1 Do
                Disp_line (i);
            End;
{dn}  #208: Go_dn;
{up}  #200: Go_up;
{lft} #203: Go_left;
{rgt} #205: Go_right;
{PgUp}#201: For i :=2 To max_x Do
              Go_up;
{PgDn}#209: For i :=2 To max_x Do
              Go_dn;
{Bgn} #199: Begin
              x :=1;
              Move_cursor;
            End;
{End} #207: Begin
              x :=max_x;
              While (x>1) And (buffer^[disp+y,x]=' ') Do
                Dec (x);
              If (x<max_x) And (buffer^[disp+y,x]<>_return) And (buffer^[disp+y,x]<>_terminal) Then
                Inc (x);
              Move_cursor;
            End;
{Supr}#211: Del_char (x,disp+y);
{BkSp}  #8: Begin
              If x>1 Then
                Begin
                  Dec (x);
                  Del_char (x,disp+y)
                End
              Else
                If disp+y>1 Then
                Begin
                  If y>0 Then
                    Dec (y)
                  Else
                    Begin
                      Dec (disp);
                      For i :=disp To disp+max_disp-1 Do
                        Disp_line (i);
                    End;
                  End_of_line;
                  Del_char (x,disp+y);
                End;
              Move_cursor;
            End;
      #27 : Inc (i); { 8-) }
{F9}  #195: Begin
              PC_to_TI (v);
              Edit_txt :=True;
            End;
{F2}  #188: TI_to_TXT;
      Else
        Insert_char (_key);
    End;
  Until (_key=#27) Or (_key=#195);

  Hide_cursor;
  End_dialog;
  Status (24,'');
  Dispose (buffer); Inc (_mfree,SizeOf (txt_buff));
End;

Function TXT_to_TI (fname : String; dest : TIstr) : pTIvar;
Var
  ch : Char;
  fsize,i : Word;
  l : LongInt;
  p : pTIvar;
  f : File;
Begin
  Assign (f,fname);
  Reset (f,1);
  fsize :=FileSize (f);
  l :=fsize+11;
  New (p); Inc (_malloc,SizeOf (TIvar));
  With p^ Do
  Begin
    typ :=$0B;
    sel :=True;
    name :=dest;
    dsize :=l;
    Dec (l,4);
    size :=l;
    Dec (l,2);
    GetMem (data,dsize); Inc (_malloc,dsize);
    data^[0] :=0;
    data^[1] :=0;
    data^[2] :=l Shr 24; { :=Byte (...) }
    data^[3] :=l Shr 16;
    data^[4] :=l Shr 8;
    data^[5] :=l;
    data^[6] :=0;
    data^[7] :=1;
    data^[8] :=32;
    BlockRead (f,data^[9],fsize);
    data^[fsize+9] :=0;
    data^[fsize+10] :=$E0;
    For i :=9 To fsize+8 Do
      If data^[i]=10 Then
        data^[i] :=13;
  End;
  Close (f);
  TXT_to_TI :=p;
End;

End.
